/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86;

import ru.ispras.microtesk.model.api.ModelBuilder;
import ru.ispras.microtesk.model.x86.metadata.MetaModelFactory;
import ru.ispras.microtesk.model.x86.mode.*;
import ru.ispras.microtesk.model.x86.op.*;

/**
 * The {@code Model} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class Model extends ModelBuilder {
  public Model() {
    super(
        "x86",
        MetaModelFactory.newMetaModel(),
        PE.newFactory(),
        TempVars.newFactory()
        );

    addMode(GPR16.INFO);
    addMode(RSEG16.INFO);
    addMode(R8.INFO);
    addMode(IMM8.INFO);
    addMode(IMM16.INFO);
    addMode(DOAM.INFO);
    addMode(RIAM_BX.INFO);
    addMode(RIAM_SI.INFO);
    addMode(RIAM_DI.INFO);
    addMode(BIAM_BX_SI.INFO);
    addMode(BIAM_BX_DI.INFO);
    addMode(BIAM_BP_SI.INFO);
    addMode(BIAM_BP_DI.INFO);
    addMode(IAM_BX_D8.INFO);
    addMode(IAM_BP_D8.INFO);
    addMode(IAM_SI_D8.INFO);
    addMode(IAM_DI_D8.INFO);
    addMode(BIDAM_BX_SI_D8.INFO);
    addMode(BIDAM_BX_DI_D8.INFO);
    addMode(BIDAM_BP_SI_D8.INFO);
    addMode(BIDAM_BP_DI_D8.INFO);
    addMode(IAM_BX_D16.INFO);
    addMode(IAM_BP_D16.INFO);
    addMode(IAM_SI_D16.INFO);
    addMode(IAM_DI_D16.INFO);
    addMode(BIDAM_BX_SI_D16.INFO);
    addMode(BIDAM_BX_DI_D16.INFO);
    addMode(BIDAM_BP_SI_D16.INFO);
    addMode(BIDAM_BP_DI_D16.INFO);

    addOperation(MOV_M8R8.INFO);
    addOperation(MOV_R8M8.INFO);
    addOperation(MOV_R8R8.INFO);
    addOperation(MOV_M16R16.INFO);
    addOperation(MOV_R16R16.INFO);
    addOperation(MOV_R16M16.INFO);
    addOperation(MOV_R16RSEG.INFO);
    addOperation(MOV_M16RSEG.INFO);
    addOperation(MOV_RSEGR16.INFO);
    addOperation(MOV_RSEGM16.INFO);
    addOperation(MOV_R8IMM8.INFO);
    addOperation(MOV_R16IMM16.INFO);
    addOperation(MOV_M8IMM8.INFO);
    addOperation(MOV_M16IMM16.INFO);
    addOperation(XCHG_R8R8.INFO);
    addOperation(XCHG_R8M8.INFO);
    addOperation(XCHG_R16R16.INFO);
    addOperation(XCHG_R16M16.INFO);
    addOperation(PUSH_RSEG.INFO);
    addOperation(PUSH_R16.INFO);
    addOperation(PUSH_M16.INFO);
    addOperation(PUSHA.INFO);
    addOperation(POP_RSEG.INFO);
    addOperation(POP_R16.INFO);
    addOperation(POP_M16.INFO);
    addOperation(POPA.INFO);
    addOperation(add_proc_byte.INFO);
    addOperation(add_proc_word.INFO);
    addOperation(ADD_M8R8.INFO);
    addOperation(ADD_M16R16.INFO);
    addOperation(ADD_R8R8.INFO);
    addOperation(ADD_R8M8.INFO);
    addOperation(ADD_R16R16.INFO);
    addOperation(ADD_R16M16.INFO);
    addOperation(ADD_R8IMM8.INFO);
    addOperation(ADD_M8IMM8.INFO);
    addOperation(ADD_R16IMM16.INFO);
    addOperation(ADD_M16IMM16.INFO);
    addOperation(ADC_M8R8.INFO);
    addOperation(ADC_M16R16.INFO);
    addOperation(ADC_R8R8.INFO);
    addOperation(ADC_R8M8.INFO);
    addOperation(ADC_R16R16.INFO);
    addOperation(ADC_R16M16.INFO);
    addOperation(ADC_R8IMM8.INFO);
    addOperation(ADC_M8IMM8.INFO);
    addOperation(ADC_R16IMM16.INFO);
    addOperation(ADC_M16IMM16.INFO);
    addOperation(sub_proc_byte.INFO);
    addOperation(sub_proc_word.INFO);
    addOperation(SUB_M8R8.INFO);
    addOperation(SUB_M16R16.INFO);
    addOperation(SUB_R8R8.INFO);
    addOperation(SUB_R8M8.INFO);
    addOperation(SUB_R16R16.INFO);
    addOperation(SUB_R16M16.INFO);
    addOperation(SUB_R8IMM8.INFO);
    addOperation(SUB_M8IMM8.INFO);
    addOperation(SUB_R16IMM16.INFO);
    addOperation(SUB_M16IMM16.INFO);
    addOperation(SBB_M8R8.INFO);
    addOperation(SBB_M16R16.INFO);
    addOperation(SBB_R8R8.INFO);
    addOperation(SBB_R8M8.INFO);
    addOperation(SBB_R16R16.INFO);
    addOperation(SBB_R16M16.INFO);
    addOperation(SBB_R8IMM8.INFO);
    addOperation(SBB_M8IMM8.INFO);
    addOperation(SBB_R16IMM16.INFO);
    addOperation(SBB_M16IMM16.INFO);
    addOperation(inc_proc_byte.INFO);
    addOperation(inc_proc_word.INFO);
    addOperation(INC_R8.INFO);
    addOperation(INC_M8.INFO);
    addOperation(INC_R16.INFO);
    addOperation(INC_M16.INFO);
    addOperation(dec_proc_byte.INFO);
    addOperation(dec_proc_word.INFO);
    addOperation(DEC_R8.INFO);
    addOperation(DEC_M8.INFO);
    addOperation(DEC_R16.INFO);
    addOperation(DEC_M16.INFO);
    addOperation(MUL_R8.INFO);
    addOperation(MUL_M8.INFO);
    addOperation(MUL_R16.INFO);
    addOperation(MUL_M16.INFO);
    addOperation(IMUL_R8.INFO);
    addOperation(IMUL_M8.INFO);
    addOperation(IMUL_R16.INFO);
    addOperation(IMUL_M16.INFO);
    addOperation(DIV_R8.INFO);
    addOperation(DIV_M8.INFO);
    addOperation(DIV_R16.INFO);
    addOperation(DIV_M16.INFO);
    addOperation(IDIV_R8.INFO);
    addOperation(IDIV_M8.INFO);
    addOperation(IDIV_R16.INFO);
    addOperation(IDIV_M16.INFO);
    addOperation(test_proc_byte.INFO);
    addOperation(test_proc_word.INFO);
    addOperation(TEST_R8R8.INFO);
    addOperation(TEST_M8R8.INFO);
    addOperation(TEST_R16R16.INFO);
    addOperation(TEST_M16R16.INFO);
    addOperation(TEST_R8IMM8.INFO);
    addOperation(TEST_M8IMM8.INFO);
    addOperation(TEST_R16IMM16.INFO);
    addOperation(TEST_M16IMM16.INFO);
    addOperation(AND_R8R8.INFO);
    addOperation(AND_M8R8.INFO);
    addOperation(AND_R8M8.INFO);
    addOperation(AND_R16R16.INFO);
    addOperation(AND_M16R16.INFO);
    addOperation(AND_R16M16.INFO);
    addOperation(AND_R8IMM8.INFO);
    addOperation(AND_M8IMM8.INFO);
    addOperation(AND_R16IMM16.INFO);
    addOperation(AND_M16IMM16.INFO);
    addOperation(or_proc_byte.INFO);
    addOperation(or_proc_word.INFO);
    addOperation(OR_R8R8.INFO);
    addOperation(OR_M8R8.INFO);
    addOperation(OR_R8M8.INFO);
    addOperation(OR_R16R16.INFO);
    addOperation(OR_M16R16.INFO);
    addOperation(OR_R16M16.INFO);
    addOperation(OR_R8IMM8.INFO);
    addOperation(OR_M8IMM8.INFO);
    addOperation(OR_R16IMM16.INFO);
    addOperation(OR_M16IMM16.INFO);
    addOperation(xor_proc_byte.INFO);
    addOperation(xor_proc_word.INFO);
    addOperation(XOR_R8R8.INFO);
    addOperation(XOR_M8R8.INFO);
    addOperation(XOR_R8M8.INFO);
    addOperation(XOR_R16R16.INFO);
    addOperation(XOR_M16R16.INFO);
    addOperation(XOR_R16M16.INFO);
    addOperation(XOR_R8IMM8.INFO);
    addOperation(XOR_M8IMM8.INFO);
    addOperation(XOR_R16IMM16.INFO);
    addOperation(XOR_M16IMM16.INFO);
    addOperation(NOT_R8.INFO);
    addOperation(NOT_M8.INFO);
    addOperation(NOT_R16.INFO);
    addOperation(NOT_M16.INFO);
    addOperation(neg_proc_byte.INFO);
    addOperation(neg_proc_word.INFO);
    addOperation(NEG_R8.INFO);
    addOperation(NEG_M8.INFO);
    addOperation(NEG_R16.INFO);
    addOperation(NEG_M16.INFO);
    addOperation(CMP_M8R8.INFO);
    addOperation(CMP_M16R16.INFO);
    addOperation(CMP_R8R8.INFO);
    addOperation(CMP_R8M8.INFO);
    addOperation(CMP_R16R16.INFO);
    addOperation(CMP_R16M16.INFO);
    addOperation(CMP_R8IMM8.INFO);
    addOperation(CMP_M8IMM8.INFO);
    addOperation(CMP_R16IMM16.INFO);
    addOperation(CMP_M16IMM16.INFO);
    addOperation(JMP_SHORT.INFO);
    addOperation(JMP_LONG.INFO);
    addOperation(JMP_R16.INFO);
    addOperation(JMP_M16.INFO);
    addOperation(JO.INFO);
    addOperation(JNO.INFO);
    addOperation(JC.INFO);
    addOperation(JNC.INFO);
    addOperation(JZ.INFO);
    addOperation(JNZ.INFO);
    addOperation(JS.INFO);
    addOperation(JNS.INFO);
    addOperation(JP.INFO);
    addOperation(JPE.INFO);
    addOperation(JNP.INFO);
    addOperation(JPO.INFO);
    addOperation(JA.INFO);
    addOperation(JAE.INFO);
    addOperation(JB.INFO);
    addOperation(JBE.INFO);
    addOperation(JE.INFO);
    addOperation(JNE.INFO);
    addOperation(JNA.INFO);
    addOperation(JNAE.INFO);
    addOperation(JNB.INFO);
    addOperation(JNBE.INFO);
    addOperation(JG.INFO);
    addOperation(JGE.INFO);
    addOperation(JL.INFO);
    addOperation(JLE.INFO);
    addOperation(JNG.INFO);
    addOperation(JNGE.INFO);
    addOperation(JNL.INFO);
    addOperation(JNLE.INFO);
    addOperation(x86.INFO);
  }
}
