/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.ProcessingElement;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.*;
import ru.ispras.microtesk.model.x86.PE;
import ru.ispras.microtesk.model.x86.TempVars;
import ru.ispras.microtesk.model.x86.mode.*;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

public final class MUL_M16 extends IsaPrimitive {
  private static final class Info extends IsaPrimitiveInfoAnd {
    Info() {
      super(
          IsaPrimitiveKind.OP,
          "MUL_M16",
          MUL_M16.class,
          null
          );
      addArgument("seg_ovrd", RSEG16.INFO);
      addArgument("op1", MOFFS.INFO);
      addShortcut(new Info_x86(), "#root");
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final IsaPrimitive op1 = (IsaPrimitive) getArgument("op1", args);

      return new MUL_M16(seg_ovrd, op1);
    }
  }
  private static final class Info_x86 extends IsaPrimitiveInfoAnd {
    Info_x86() {
      super(
          IsaPrimitiveKind.OP,
          "MUL_M16",
          x86.class,
          null
          );
      addArgument("seg_ovrd", RSEG16.INFO);
      addArgument("op1", MOFFS.INFO);
    }

    @Override
    public IsaPrimitive create(final Map<String, IsaPrimitive> args) {
      final RSEG16 seg_ovrd = (RSEG16) getArgument("seg_ovrd", args);
      final IsaPrimitive op1 = (IsaPrimitive) getArgument("op1", args);

      return new x86(
        new MUL_M16(
          seg_ovrd,
          op1
        )
      );
    }
  }
  public static final IsaPrimitiveInfoAnd INFO = new Info();

  public final RSEG16 seg_ovrd;
  public final IsaPrimitive op1;

  public MUL_M16(final RSEG16 seg_ovrd, final IsaPrimitive op1) {
    assert RSEG16.INFO.isSupported(seg_ovrd);
    assert MOFFS.INFO.isSupported(op1);
    this.seg_ovrd = seg_ovrd;
    this.op1 = op1;
  }

  @Override
  public String syntax(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("MUL %s:%s", seg_ovrd.syntax(vars__), op1.syntax(vars__));
  }

  @Override
  public String image(final TemporaryVariables tempVars) {
    final TempVars vars__ = (TempVars) tempVars;
    return String.format("001%s11011110111%s000%s%s", seg_ovrd.image(vars__), vars__.mod.access().load().toString(), vars__.rm.access().load().toString(), op1.image(vars__));
  }

  @Override
  public void action(final ProcessingElement procElem, final TemporaryVariables tempVars) {
    final PE pe__ = (PE) procElem;
    final TempVars vars__ = (TempVars) tempVars;
    vars__.base.access().store(Data.zeroExtend(ADDR, seg_ovrd.access(pe__, vars__).load()).shiftLeft(Data.valueOf(ADDR, 0x4)));
    vars__.tmpdw_op1.access().store(Data.zeroExtend(DWORD, pe__.AX.access().load()).multiply(Data.zeroExtend(DWORD, Location.concat(pe__.M.access(vars__.base.access().load().add(op1.access(pe__, vars__).load())), pe__.M.access(vars__.base.access().load().add(op1.access(pe__, vars__).load()).add(Data.valueOf(ADDR, 0x1)))).load())));
    vars__.instr_size.access().store(vars__.instr_size.access().load().add(Data.valueOf(SIZE, 0x3)));
    op1.execute(pe__, vars__);
    pe__.AX.access().store(vars__.tmpdw_op1.access().bitField(0, 15).load());
    pe__.DX.access().store(vars__.tmpdw_op1.access().bitField(16, 31).load());
    if (!pe__.DX.access().load().equals(Data.valueOf(WORD, 0x0))) {
      pe__.OF.access().store(Data.valueOf(BIT, 0x1));
      pe__.CF.access().store(Data.valueOf(BIT, 0x1));
    } else {
      pe__.OF.access().store(Data.valueOf(BIT, 0x0));
      pe__.CF.access().store(Data.valueOf(BIT, 0x0));
    }
  }
}